3 # Copyright (c) 2005, 2006 Junio C Hamano
8 git am [options] [(<mbox>|<Maildir>)...]
9 git am [options] (--resolved | --skip | --abort)
11 i,interactive run interactively
12 b,binary* (historical option -- no-op)
13 3,3way allow fall back on 3way merging if needed
15 s,signoff add a Signed-off-by line to the commit message
16 u,utf8 recode into utf8 (default)
17 k,keep pass -k flag to git-mailinfo
18 keep-cr pass --keep-cr flag to git-mailsplit for mbox format
19 no-keep-cr do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
20 c,scissors strip everything before a scissors line
21 whitespace= pass it through git-apply
22 ignore-space-change pass it through git-apply
23 ignore-whitespace pass it through git-apply
24 directory= pass it through git-apply
25 exclude= pass it through git-apply
26 C= pass it through git-apply
27 p= pass it through git-apply
28 patch-format= format the patch(es) are in
29 reject pass it through git-apply
30 resolvemsg= override error message when patch failure occurs
31 continue continue applying patches after resolving a conflict
32 r,resolved synonyms for --continue
33 skip skip the current patch
34 abort restore the original branch and abort the patching operation.
35 committer-date-is-author-date lie about committer date
36 ignore-date use current timestamp for author date
37 rerere-autoupdate update the index with reused conflict resolution if possible
38 rebasing* (internal use for git-rebase)"
42 prefix=$(git rev-parse --show-prefix)
47 git var GIT_COMMITTER_IDENT >/dev/null ||
48 die "$(gettext "You need to set your committer info first")"
50 if git rev-parse --verify -q HEAD >/dev/null
58 if test '' != "$interactive"
62 if test '' != "$threeway"
68 git rev-parse --sq-quote "$@"
72 echo "$1" >"$dotest/next"
73 git rev-parse --verify -q HEAD >"$dotest/abort-safety"
78 if test -f "$dotest/dirtyindex"
83 if ! test -s "$dotest/abort-safety"
88 abort_safety=$(cat "$dotest/abort-safety")
89 if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
93 gettextln "You seem to have moved HEAD since the last 'am' failure.
94 Not rewinding to ORIG_HEAD" >&2
98 stop_here_user_resolve () {
99 if [ -n "$resolvemsg" ]; then
100 printf '%s\n' "$resolvemsg"
103 eval_gettextln "When you have resolved this problem run \"\$cmdline --resolved\".
104 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
105 To restore the original branch and stop patching run \"\$cmdline --abort\"."
111 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
112 "$dotest/patch" "$dotest/info"
113 echo "$next" >"$dotest/next"
119 gettextln "Cannot fall back to three-way merge."
124 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
126 rm -fr "$dotest"/patch-merge-*
127 mkdir "$dotest/patch-merge-tmp-dir"
129 # First see if the patch records the index info that we can use.
130 git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
132 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
133 git write-tree >"$dotest/patch-merge-base+" ||
134 cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
136 say Using index info to reconstruct a base tree...
137 if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
138 git apply --cached <"$dotest/patch"
140 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
141 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
143 cannot_fallback "$(gettext "Did you hand edit your patch?
144 It does not apply to blobs recorded in its index.")"
147 test -f "$dotest/patch-merge-index" &&
148 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
149 orig_tree=$(cat "$dotest/patch-merge-base") &&
150 rm -fr "$dotest"/patch-merge-* || exit 1
152 say "$(gettext "Falling back to patching base and 3-way merge...")"
154 # This is not so wrong. Depending on which base we picked,
155 # orig_tree may be wildly different from ours, but his_tree
156 # has the same set of wildly different changes in parts the
157 # patch did not touch, so recursive ends up canceling them,
158 # saying that we reverted all those changes.
160 eval GITHEAD_$his_tree='"$FIRSTLINE"'
161 export GITHEAD_$his_tree
162 if test -n "$GIT_QUIET"
164 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
166 git-merge-recursive $orig_tree -- HEAD $his_tree || {
167 git rerere $allow_rerere_autoupdate
168 echo Failed to merge in the changes.
171 unset GITHEAD_$his_tree
175 test $# = 0 || echo >&2 "$@"
182 check_patch_format () {
183 # early return if patch_format was set from the command line
184 if test -n "$patch_format"
189 # we default to mbox format if input is from stdin and for
191 if test $# = 0 || test "x$1" = "x-" || test -d "$1"
197 # otherwise, check the first few non-blank lines of the first
198 # patch to try to detect its format
200 # Start from first line containing non-whitespace
209 "From "* | "From: "*)
212 '# This series applies on GIT commit'*)
213 patch_format=stgit-series
215 "# HG changeset patch")
219 # if the second line is empty and the third is
220 # a From, Author or Date entry, this is very
221 # likely an StGIT patch
223 ,"From: "* | ,"Author: "* | ,"Date: "*)
231 if test -z "$patch_format" &&
236 # This begins with three non-empty lines. Is this a
237 # piece of e-mail a-la RFC2822? Grab all the headers,
238 # discarding the indented remainder of folded lines,
239 # and see if it looks like that they all begin with the
240 # header field names...
242 sed -n -e '/^$/q' -e '/^[ ]/d' -e p |
243 sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
246 } < "$1" || clean_abort
250 case "$patch_format" in
252 if test -n "$rebasing" || test t = "$keepcr"
258 git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
264 clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
266 series_dir=`dirname "$1"`
273 set "$@" "$series_dir/$filename"
275 # remove the safety x
277 # remove the arg coming from the first-line comment
279 } < "$series_file" || clean_abort
280 # set the patch format appropriately
282 # now handle the actual StGIT patches
289 this=`expr "$this" + 1`
290 msgnum=`printf "%0${prec}d" $this`
291 # Perl version of StGIT parse_patch. The first nonemptyline
292 # not starting with Author, From or Date is the
293 # subject, and the body starts with the next nonempty
294 # line not starting with Author, From or Date
295 perl -ne 'BEGIN { $subject = 0 }
296 if ($subject > 1) { print ; }
297 elsif (/^\s+$/) { next ; }
298 elsif (/^Author:/) { s/Author/From/ ; print ;}
299 elsif (/^(From|Date)/) { print ; }
305 print "Subject: ", $_ ;
308 ' < "$stgit" > "$dotest/$msgnum" || clean_abort
310 echo "$this" > "$dotest/last"
315 if test -n "$patch_format"
317 clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
319 clean_abort "$(gettext "Patch format detection failed.")"
326 dotest="$GIT_DIR/rebase-apply"
327 sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
328 resolvemsg= resume= scissors= no_inbody_headers=
330 committer_date_is_author_date=
332 allow_rerere_autoupdate=
334 if test "$(git config --bool --get am.keepcr)" = true
351 utf8=t ;; # this is now default
360 -r|--resolved|--continue)
367 rebasing=t threeway=t keep=t scissors=f no_inbody_headers=t ;;
369 die "$(gettext "-d option is no longer supported. Do not use.")"
372 shift; resolvemsg=$1 ;;
373 --whitespace|--directory|--exclude)
374 git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
376 git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
378 shift ; patch_format="$1" ;;
379 --reject|--ignore-whitespace|--ignore-space-change)
380 git_apply_opt="$git_apply_opt $1" ;;
381 --committer-date-is-author-date)
382 committer_date_is_author_date=t ;;
385 --rerere-autoupdate|--no-rerere-autoupdate)
386 allow_rerere_autoupdate="$1" ;;
401 # If the dotest directory exists, but we have finished applying all the
402 # patches in them, clear it out.
403 if test -d "$dotest" &&
404 last=$(cat "$dotest/last") &&
405 next=$(cat "$dotest/next") &&
407 test "$next" -gt "$last"
414 case "$#,$skip$resolved$abort" in
416 # Explicit resume command and we do not have file, so
420 # No file input but without resume parameters; catch
421 # user error to feed us a patch from standard input
422 # when there is already $dotest. This is somewhat
423 # unreliable -- stdin could be /dev/null for example
424 # and the caller did not intend to feed us a patch but
425 # wanted to continue unattended.
432 die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
435 case "$skip,$abort" in
437 die "$(gettext "Please make up your mind. --skip or --abort?")"
441 git read-tree --reset -u HEAD HEAD
442 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
444 git update-ref ORIG_HEAD $orig_head
447 if test -f "$dotest/rebasing"
449 exec git rebase --abort
454 git read-tree --reset -u HEAD ORIG_HEAD
460 rm -f "$dotest/dirtyindex"
462 # Make sure we are not given --skip, --resolved, nor --abort
463 test "$skip$resolved$abort" = "" ||
464 die "$(gettext "Resolve operation not in progress, we are not resuming.")"
467 mkdir -p "$dotest" || exit
469 if test -n "$prefix" && test $# != 0
474 test -n "$first" && {
478 if is_absolute_path "$arg"
482 set "$@" "$prefix$arg"
488 check_patch_format "$@"
492 # -i can and must be given when resuming; everything
494 echo " $git_apply_opt" >"$dotest/apply-opt"
495 echo "$threeway" >"$dotest/threeway"
496 echo "$sign" >"$dotest/sign"
497 echo "$utf8" >"$dotest/utf8"
498 echo "$keep" >"$dotest/keep"
499 echo "$scissors" >"$dotest/scissors"
500 echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
501 echo "$GIT_QUIET" >"$dotest/quiet"
502 echo 1 >"$dotest/next"
503 if test -n "$rebasing"
505 : >"$dotest/rebasing"
507 : >"$dotest/applying"
508 if test -n "$HAS_HEAD"
510 git update-ref ORIG_HEAD HEAD
512 git update-ref -d ORIG_HEAD >/dev/null 2>&1
517 git update-index -q --refresh
523 files=$(git ls-files) ;;
525 files=$(git diff-index --cached --name-only HEAD --) ;;
529 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
530 die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
534 if test "$(cat "$dotest/utf8")" = t
540 if test "$(cat "$dotest/keep")" = t
544 case "$(cat "$dotest/scissors")" in
546 scissors=--scissors ;;
548 scissors=--no-scissors ;;
550 if test "$(cat "$dotest/no_inbody_headers")" = t
552 no_inbody_headers=--no-inbody-headers
556 if test "$(cat "$dotest/quiet")" = t
560 if test "$(cat "$dotest/threeway")" = t
564 git_apply_opt=$(cat "$dotest/apply-opt")
565 if test "$(cat "$dotest/sign")" = t
567 SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
569 s/^/Signed-off-by: /'
575 last=`cat "$dotest/last"`
576 this=`cat "$dotest/next"`
579 this=`expr "$this" + 1`
583 while test "$this" -le "$last"
585 msgnum=`printf "%0${prec}d" $this`
586 next=`expr "$this" + 1`
587 test -f "$dotest/$msgnum" || {
593 # If we are not resuming, parse and extract the patch information
594 # into separate files:
595 # - info records the authorship and title
596 # - msg is the rest of commit log message
597 # - patch is the patch body.
599 # When we are resuming, these files are either already prepared
600 # by the user, or the user can tell us to do so by --resolved flag.
603 git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
604 <"$dotest/$msgnum" >"$dotest/info" ||
607 # skip pine's internal folder data
608 sane_grep '^Author: Mail System Internal Data$' \
609 <"$dotest"/info >/dev/null &&
612 test -s "$dotest/patch" || {
613 eval_gettextln "Patch is empty. Was it split wrong?
614 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
615 To restore the original branch and stop patching run \"\$cmdline --abort\"."
618 rm -f "$dotest/original-commit" "$dotest/author-script"
619 if test -f "$dotest/rebasing" &&
620 commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
621 -e q "$dotest/$msgnum") &&
622 test "$(git cat-file -t "$commit")" = commit
624 git cat-file commit "$commit" |
625 sed -e '1,/^$/d' >"$dotest/msg-clean"
626 echo "$commit" > "$dotest/original-commit"
627 get_author_ident_from_commit "$commit" > "$dotest/author-script"
630 sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
634 git stripspace > "$dotest/msg-clean"
639 if test -f "$dotest/author-script"
641 eval $(cat "$dotest/author-script")
643 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
644 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
645 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
648 if test -z "$GIT_AUTHOR_EMAIL"
650 gettextln "Patch does not have a valid e-mail address."
654 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
658 if test '' != "$SIGNOFF"
661 sed -ne '/^Signed-off-by: /p' \
662 "$dotest/msg-clean" |
666 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
667 test '' = "$LAST_SIGNED_OFF_BY" && echo
674 if test -s "$dotest/msg-clean"
676 cat "$dotest/msg-clean"
678 if test '' != "$ADD_SIGNOFF"
682 } >"$dotest/final-commit"
685 case "$resolved$interactive" in
687 # This is used only for interactive view option.
688 git diff-index -p --cached HEAD -- >"$dotest/patch"
694 if test "$interactive" = t
697 die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
699 while test "$action" = again
701 gettextln "Commit Body is:"
702 echo "--------------------------"
703 cat "$dotest/final-commit"
704 echo "--------------------------"
705 # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
706 # in your translation. The program will only accept English
707 # input at this point.
708 gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
712 [aA]*) action=yes interactive= ;;
713 [nN]*) action=skip ;;
714 [eE]*) git_editor "$dotest/final-commit"
717 git_pager "$dotest/patch" ;;
725 if test -f "$dotest/final-commit"
727 FIRSTLINE=$(sed 1q "$dotest/final-commit")
732 if test $action = skip
738 if test -x "$GIT_DIR"/hooks/applypatch-msg
740 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
744 say "$(eval_gettext "Applying: \$FIRSTLINE")"
748 # When we are allowed to fall back to 3-way later, don't give
749 # false errors during the initial attempt.
751 if test "$threeway" = t
753 squelch='>/dev/null 2>&1 '
755 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
759 # Resolved means the user did all the hard work, and
760 # we do not have to do any patch application. Just
761 # trust what the user has in the index file and the
764 git diff-index --quiet --cached HEAD -- && {
765 gettextln "No changes - did you forget to use 'git add'?
766 If there is nothing left to stage, chances are that something else
767 already introduced the same changes; you might want to skip this patch."
768 stop_here_user_resolve $this
770 unmerged=$(git ls-files -u)
771 if test -n "$unmerged"
773 gettextln "You still have unmerged paths in your index
774 did you forget to use 'git add'?"
775 stop_here_user_resolve $this
782 if test $apply_status != 0 && test "$threeway" = t
786 # Applying the patch to an earlier tree and merging the
787 # result may have produced the same tree as ours.
788 git diff-index --quiet --cached HEAD -- && {
789 say "$(gettext "No changes -- Patch already applied.")"
793 # clear apply_status -- we have successfully merged.
797 if test $apply_status != 0
799 eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
800 stop_here_user_resolve $this
803 if test -x "$GIT_DIR"/hooks/pre-applypatch
805 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
808 tree=$(git write-tree) &&
810 if test -n "$ignore_date"
814 parent=$(git rev-parse --verify -q HEAD) ||
815 say >&2 "$(gettext "applying to an empty history")"
817 if test -n "$committer_date_is_author_date"
819 GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
820 export GIT_COMMITTER_DATE
822 git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
824 git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
827 if test -f "$dotest/original-commit"; then
828 echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
831 if test -x "$GIT_DIR"/hooks/post-applypatch
833 "$GIT_DIR"/hooks/post-applypatch
839 if test -s "$dotest"/rewritten; then
840 git notes copy --for-rewrite=rebase < "$dotest"/rewritten
841 if test -x "$GIT_DIR"/hooks/post-rewrite; then
842 "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten